package com.ibm.oti.reflect;

/*
 * Licensed Materials - Property of IBM,
 *     Copyright IBM Corp. 2005, 2010  All Rights Reserved
 */

import java.lang.annotation.Annotation;
import java.lang.ref.SoftReference;

public class Field {
	private java.lang.reflect.Field field;
	private SoftReference<Annotations> annotations;

public Field(java.lang.reflect.Field field) {
	this.field = field;
}

private synchronized Annotations getAnnotations() {
	Annotations ans;
	if (annotations == null || (ans = annotations.get()) == null) {
		annotations = new SoftReference<Annotations>(ans = new Annotations(AnnotationParser.parseAnnotations(field)));
	}
	return ans;
}

public <T extends Annotation> T getAnnotation(Class<T> cl) {
	if (cl == null) throw new NullPointerException();
	return getAnnotations().getAnnotation(cl);
}

public Annotation[] getDeclaredAnnotations() {
	return getAnnotations().getAnnotations().clone();
}

}
